/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2.1

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    Thanks : 4lj <4lj@flow.le.to> wrote patches to avoid source IP address
             spoofing problem.
             4lj <4lj@flow.le.to> implements "tmpfile hold" mode

 *****************************************************************************/

#ifndef __ANALYZE_H__
#define __ANALYZE_H__

#include "gddconfig.h"

enum{
    STATE_SYN,
    STATE_ESTABLISHED
};

#define TH_SYNTIMEOUT   5               /* Timeout value for SYN */
#define MINSIZE_IP      20              /* Minimum size of IP header */
#define MINSIZE_TCP     20              /* Minimum size of TCP header */

/* Connection table list */
struct ctl{
    struct ctl      *next_p;        /* Pointer to next element */
    char            start_time[512];/* Session start time */
    char            sourceIP[16];   /* Source IP address */
    char            destIP[16];     /* Destination IP address */
    unsigned short  sourcePort;     /* Source port */
    unsigned short  destPort;       /* Destination port */
    int             state;          /* State of this connection */
    unsigned long   SYNtick;        /* Tick when SYN received    */
    unsigned long   b_seq;          /* Before seq number */
    unsigned long   b_ack;          /* Before ack number */
    unsigned long   b_dlen;         /* Before length of data */
	unsigned char   logtype;        /* Log type */
};

typedef struct ctl  CONN_LIST;

extern int packet_analysis(GDDCONFIG *,unsigned char *,unsigned long);
extern int init_connection_table(void);
extern int release_connection_table(void);
extern int fourceterm_connection(GDDCONFIG *gddc);
extern int enum_connection(GDDCONFIG *gddc);

#endif
