/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    Thanks : rocket <rocket_z@dial.104.net> helped me to develop this code !

 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "param.h"
#include "depend.h"
#include "defaultnic.h"

/*============================================================================
 Get default NIC
 [INPUT]
  none
 [RETURN]
  if default nic is not found, return NULL
  otherwise, name of default nic is returned
  ============================================================================
*/
char *getdefaultnic(void)
{
    static char     nicname[MAXLEN_NICNAME];
    static char     pathenv[4096];
    static char     pathenv_original[2048];
    char            *p;
    int             pp_stdout[2],r;
    pid_t           pid;

    if (strlen(PATHENV)+5 >=sizeof(pathenv))
        return(NULL);
    if ((p=getenv("PATH"))!=NULL){
        if (strlen(p)>=sizeof(pathenv_original))
            return(NULL);
        strcpy(pathenv_original,p);
    }
    sprintf(pathenv,"PATH=%s",PATHENV);
    putenv(pathenv);
    pipe(pp_stdout);
    if ((pid=fork())==-1) return(NULL);
    else if (pid>0){
        close(pp_stdout[1]);
        if ((r=read(pp_stdout[0],nicname,sizeof(nicname)-1))<=0)
            return(NULL);
        nicname[r]='\0';    
        close(pp_stdout[0]);
    }else{
        close(1);
        dup(pp_stdout[1]);  
        close(pp_stdout[1]);
        close(pp_stdout[0]);
        close(2);
        execl("/bin/sh","sh","-c",
            "ifconfig -a | awk -F: '/BROADCAST/{print $1}' | head -1",
            NULL);  
        exit(1);
    }
    for (r=strlen(nicname)-1;r>=0;r--)
        if (isprint((int)nicname[r])) break;
    nicname[r+1]='\0';
    if (p!=NULL){
        sprintf(pathenv,"PATH=%s",pathenv_original);
        putenv(pathenv);
    }
    return(nicname);
}
