/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 *****************************************************************************/

#ifndef __DEPEND_H__
#define __DEPEND_H__

#include <sys/types.h>
#include <winsock2.h>
#include <windows.h>
#include <windowsx.h>
#include <process.h>
#include <commctrl.h>
#include "getopt.h"
#include "gui_win32_console.h"

#define GDD_VERSION         "2.4"
#define DFL_LOGDIR          ""
#define DFL_LOGFILE         "log"
#define DFL_ERRLOG          "errlog"
#define DFL_TEMPLOGDIR      "tmp"
#define DFL_CFGFILE         "gdd_win32.conf"
#define NICDEVDIR           ""
#define EGREP               "grep.exe"
#define CLASSNAME           "GreedyDog"
#define WORKDIR             "gddwork"
#define getuid()            0
#define fork()              0
#define pid_t               int
#define uid_t               int
#define u_int8_t            unsigned char
#define u_int16_t           unsigned short
#define tcp_seq             unsigned int
#define snprintf            _snprintf

#define SIO_RCVALL          0x98000001
#define WM_ASYNC_SELECT     WM_USER+1

/*----- start : ported from Linux /usr/include/netinet/ ------*/

#define TH_FIN              0x01
#define TH_SYN              0x02
#define TH_RST              0x04
#define TH_PUSH             0x08
#define TH_ACK              0x10
#define TH_URG              0x20

struct ip{
    u_int8_t        ip_hv;          /* header and version */
    u_int8_t        ip_tos;         /* type of service */
    u_short         ip_len;         /* total length */
    u_short         ip_id;          /* identification */
    u_short         ip_off;         /* fragment offset field */
    u_int8_t        ip_ttl;         /* time to live */
    u_int8_t        ip_p;           /* protocol */
    u_short         ip_sum;         /* checksum */
    struct in_addr  ip_src,ip_dst;  /* source and dest address */
};
#define ip_hl       ip_hv&0x0f
#define ip_v        ip_hv>>4

struct tcphdr{
    u_int16_t       th_sport;       /* source port */
    u_int16_t       th_dport;       /* destination port */
    tcp_seq         th_seq;         /* sequence number */
    tcp_seq         th_ack;         /* acknowledgement number */
    u_int8_t        th_xo;          /* offset */
    u_int8_t        th_flags;       /* tcp flags */
    u_int16_t       th_win;         /* window  */
    u_int16_t       th_sum;         /* checksum  */
    u_int16_t       th_urp;         /* urgent pointer  */
};

/*----- end : ported from Linux /usr/include/netinet/ ------*/

#define th_x2               th_xo&0x0f
#define th_off              th_xo>>4

#define SIZE_OF_ETHHDR      0
#define DIRSEPCHR           "\\"
#define DFL_NIT_DEV         ""
#define CHUNKSIZE           65535

void console_write(char *buf);

#endif
